//#include "sip.h"

void setup_webserver(void) {
  server.on("/", HTTP_GET, indexpage);
  server.on("/config", HTTP_GET, configpage);
  server.on("/reboot", HTTP_POST, reboot);
  server.on("/open", HTTP_POST, tueroeffner);
  server.on("/dial", HTTP_POST, dial);
  server.on("/mute_telefon", HTTP_POST, telefon_ein_aus);
  server.on("/mute_klingel", HTTP_POST,klingel_ein_aus);
  server.on("/save_config", HTTP_POST, handle_config);
  server.onNotFound(handleNotFound);
  server.begin();
  return;
}



String html_head() {
  String head = "<!DOCTYPE html>"
                "<html lang=de><head><meta name=viewport content=width=device-width, initial-scale=1.0, user-scalable=no>"
                "<title>"
                + String(cfg.wifi_hostname) + "</title>"
                                              "<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}"
                                              "h1 {font-size: 32px; color: red; display: inline; }"
                                              "h2 {font-size: 16px; color: blue; display: inline;}"
                                              "h3 {font-size: 16px; color: black; display: inline;}"
                                              "h4 {font-size: 12px; color: black; display: inline;}"
                                              "h5 {font-size: 18px; color: red; display: inline;}"
                                              "table {table-align: center; border: 1px solid black;}"  //border: 1px solid black;
                                              "td {text-align: left;}"
                                              "body {background-color: #CEF6EC; margin-top: 50px; }"
                                              "</style><body><center><h1>"
                + String(cfg.wifi_hostname) + "</h1><br><h4> Firmware V. " FIRMWARE "</h4><br><br><br>";
  return head;
}


void indexpage() { 

  String html_buf = html_head();

  html_buf += "<form action=\"/open\" method=\"POST\"><input style=\"height: 70px; width: 200px; background-color: #F7BE81; font-size: 20px; font-weight: bold; \" type=\"submit\" value=\"T&uuml;r&ouml;ffner\"></form><br><br>";
  if (klingel_stumm == false) {
    html_buf += "<br><form action=\"/mute_klingel\" method=\"POST\"><input type=\"submit\" value=\"Klingel stummschalten\"></form><br>";
  } else if (klingel_stumm == true) {
    html_buf += "<h5>> Klingel stummgeschaltet <</h5><br>";
    html_buf += "<br><form action=\"/mute_klingel\" method=\"POST\"><input type=\"submit\" value=\"Stummschaltung Klingel aufheben\"></form><br>";
  }

  if (telefone_stumm == false) {
    html_buf += "<br><form action=\"/mute_telefon\" method=\"POST\"><input type=\"submit\" value=\"Telefone stummschalten\"></form><br>";
  } else if (telefone_stumm == true) {
    html_buf += "<h5>> Telefone stummgeschaltet <</h5><br>";
    html_buf += "<br><form action=\"/mute_telefon\" method=\"POST\"><input type=\"submit\" value=\"Stummschaltung Telefone aufheben\"></form><br>";
  }
  
  if (mqtt_auto_disabled == true){
    html_buf += "<br><h4>Keine Verbindung zum MQTT-Broker.<br>MQTT automatisch deaktiviert.</h4>";
  }
  html_buf += "<br><br><table><tr><th><h2>Klingelzeiten:</h2></th></tr>";
  for (uint8_t i = 0; i < 10; i++) {
    html_buf += "<tr><td><h3>" + String(i + 1) + ". " + String(klingelzeiten[i]) + "</h3></td></tr>";
  }
  html_buf += "</table><br><br>";
  html_buf += "<table border=1 cellspacing=1><tr><th colspan=2><h2>Systemdaten</h2></th></tr>";
  html_buf += "<tr><td><h2>Firmware:</h2></td><td><h3>" FIRMWARE "<button>Firmwareupdate</button>[In dieser Version nicht verf&uuml;gbar]</h3></td></tr>";
  html_buf += "<tr><td><h2>Laufzeit:</h2></td><td><h3><form action=\"/reboot\" method=\"POST\"><h3>" + String(systemlaufzeit) + "<input type=\"submit\" value=\"Reboot\"></form></h3></td></tr>";
  html_buf += "<tr><td><h2>WiFi Signalst&auml;rke:</h2></td><td><h3>" + String(WiFi.RSSI()) + "dbm</h3></td></tr>";
  html_buf += "<tr><td><h2>WiFi-Signalqualit&auml;t:</h2></td><td><h3>" + getWifiQuality() + "</h3></td></tr>";
  html_buf += "<tr><td><h2>Kanal:</h2></td><td><h3>" + String(WiFi.channel()) + "</h3></td></tr>";
  html_buf += "<tr><td><h2>Systemzeit:</h2></td><td><h3>" + timeClient.getFullDateAndTime() + "</h3></td></tr>";
  html_buf += "<tr><td><h2>Freier RAM:</h2></td><td><h3>" + String(ESP.getFreeHeap()) + " Bytes</h3></td></tr>";
  html_buf += "<tr><td><h2>Espressif SDK-Version:</h2></td><td><h3>" + String(ESP.getSdkVersion()) + "</h3></td></tr>";
  html_buf += "<tr><td><h2>Arduino-Coreversion:</h2></td><td><h3>" + ESP.getCoreVersion() + "</h3></td></tr>";
  html_buf += "<tr><td><h2>Flashspeicher gesamt:</h2></td><td><h3>" + String(ESP.getFlashChipSize()) + " Bytes</h3></td></tr>";
  html_buf += "<tr><td><h2>Durch Firmware belegt:</h2></td><td><h3>" + String(ESP.getSketchSize()) + " Bytes</h3></td></tr>";
  html_buf += "<tr><td><h2>Flashspeicher frei:</h2></td><td><h3>" + String(ESP.getFreeSketchSpace()) + " Bytes</h3></td></tr>";
  html_buf += "<tr><td colspan=2><a href=/config><button>Einstellungen</button></a></td></tr>";
  html_buf += "<tr><th colspan=2><h2>Systemlog:</h2></th></tr>";
  html_buf += "<tr><td colspan=2><h3>";
  for (uint8_t j = 0; j < 15; j++) {
    html_buf += String(syslog[j]);
    if (j < 14) {
      html_buf += "<br>";
    }
  }
  html_buf += "</h3></td></tr></table></center></body></html>";
  server.send(200, "text/html", html_buf.c_str());
  return;
}



void configpage() {

  String html_buf = html_head();
  html_buf += "<br><h3>Einstellungen</h3>&nbsp;&nbsp;</h2><a href=/><button>Zur&uuml;ck</button></a></h2>";
  html_buf += "<br><br><table border=1 cellspacing=1><tr><th colspan=2><h2>Netzwerk</th></tr>";
  //WiFi
  html_buf += "<tr><td><h3><form action=\"/save_config\" method=\"POST\">WiFi-SSID:</h3></td><td><form action=\"/save_config\" method=\"POST\"><input type=\"text\" name=\"WIFISSID\" value=\"" + String(cfg.wifissid) + "\" size=\"25\"></td></tr>";
  html_buf += "<tr><td><h3>Passwort:</h3></td><td><input type=\"text\" name=\"WIFIPASSWORD\" value=\"" + String(cfg.wifipassword) + "\" size=\"40\"></td></tr>";
  //Hostname
  html_buf += "<tr><td><h3>Hostname:</h3></td><td><input type=\"text\" name=\"HOSTNAME\" value=\"" + String(cfg.wifi_hostname) + "\" size=\"25\"></td></tr>";
  //IP Adresse
  html_buf += "<tr><td><h3>IP-Adresse:</h3></td><td>";
  html_buf += "<input type=\"text\" name=\"IP0\" value=\"" + String(cfg.ip[0]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"IP1\" value=\"" + String(cfg.ip[1]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"IP2\" value=\"" + String(cfg.ip[2]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"IP3\" value=\"" + String(cfg.ip[3]) + "\" size=\"3\"></td></tr>";
  //Subnetsmaske
  html_buf += "<tr><td><h3>Subnetzmaske:</h3></td><td>";
  html_buf += "<input type=\"text\" name=\"MASK0\" value=\"" + String(cfg.mask[0]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"MASK1\" value=\"" + String(cfg.mask[1]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"MASK2\" value=\"" + String(cfg.mask[2]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"MASK3\" value=\"" + String(cfg.mask[3]) + "\" size=\"3\"></td></tr>";
  //Gateway
  html_buf += "<tr><td><h3>Gateway:</h3></td><td>";
  html_buf += "<input type=\"text\" name=\"GW0\" value=\"" + String(cfg.gw[0]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"GW1\" value=\"" + String(cfg.gw[1]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"GW2\" value=\"" + String(cfg.gw[2]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"GW3\" value=\"" + String(cfg.gw[3]) + "\" size=\"3\"></td></tr>";
  //DNS
  html_buf += "<tr><td><h3>DNS-Server:</h3></td><td>";
  html_buf += "<input type=\"text\" name=\"DNS0\" value=\"" + String(cfg.dns[0]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"DNS1\" value=\"" + String(cfg.dns[1]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"DNS2\" value=\"" + String(cfg.dns[2]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"DNS3\" value=\"" + String(cfg.dns[3]) + "\" size=\"3\"></td></tr>";
  //NTP
  html_buf += "<tr><th colspan=2><h2>NTP</h2></th></tr>";
  html_buf += "<tr><td><h3>NTP-Server:</h3></td><td><input type=\"text\" name=\"NTPSERVER\" value=\"" + String(cfg.ntpServerName) + "\" size=\"25\"></h3></td></tr>";
  if (cfg.dst_aktiv == 1) {
    html_buf += "<tr><td><h3>Sommerzeit:</h3></td><td><input type=\"checkbox\" name=\"DST\" value=\"true\"checked></td></tr>";
  } else {
    html_buf += "<tr><td><h3>Sommerzeit:</h3></td><td><input type=\"checkbox\" name=\"DST\" value=\"true\"></td></tr>";
  }
  //MQTT
  html_buf += "<tr><th colspan=2><h2>MQTT</h2></th></tr>";
  if (cfg.mqtt_aktiv == 1) {
    html_buf += "<tr><td><h3>MQTT Aktiv:</h3></td><td><input type=\"checkbox\" name=\"MQTTACTIVE\" value=\"true\"checked></td></tr>";
  } else {
    html_buf += "<tr><td><h3>MQTT Aktiv:</h3></td><td><input type=\"checkbox\" name=\"MQTTACTIVE\" value=\"true\"></td></tr>";
  }
  html_buf += "<tr><td><h3>MQTT-Server:</h3></td><td>";
  html_buf += "<input type=\"text\" name=\"MQTTIP0\" value=\"" + String(cfg.mqttIP[0]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"MQTTIP1\" value=\"" + String(cfg.mqttIP[1]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"MQTTIP2\" value=\"" + String(cfg.mqttIP[2]) + "\" size=\"3\">.";
  html_buf += "<input type=\"text\" name=\"MQTTIP3\" value=\"" + String(cfg.mqttIP[3]) + "\" size=\"3\"></td></tr>";
  html_buf += "<tr><td><h3>MQTT-Port:</h3></td><td><input type=\"text\" name=\"MQTTPORT\" value=\"" + String(cfg.mqttport) + "\" size=\"4\"></td></tr>";
  html_buf += "<tr><td><h3>MQTT-ID:</h3></td><td><input type=\"text\" name=\"MQTTID\" value=\"" + String(cfg.mqtt_id) + "\" size=\"32\"></td></tr>";
  html_buf += "<tr><td><h3>MQTT-Benutzer:</h3></td><td><input type=\"text\" name=\"MQTTUSER\" value=\"" + String(cfg.mqtt_user) + "\" size=\"16\"></td></tr>";
  html_buf += "<tr><td><h3>MQTT-Passwort:</h3></td><td><input type=\"text\" name=\"MQTTPASSWD\" value=\"" + String(cfg.mqtt_passwd) + "\" size=\"16\"></td></tr>";
  //SIP
  html_buf += "<tr><th colspan=2><h2>SIP</h2></th></tr>";
  html_buf += "<tr><td><h3>SIP-Server:</h3></td><td><input type=\"text\" name=\"SIPSERVER\" value=\"" + String(cfg.sipserver) + "\" size=\"20\"></td></tr>";
  html_buf += "<tr><td><h3>SIP-Port:</h3></td><td><input type=\"text\" name=\"SIPPORT\" value=\"" + String(cfg.sipport) + "\" size=\"5\"></td></tr>";
  html_buf += "<tr><td><h3>SIP-User:</h3></td><td><input type=\"text\" name=\"SIPUSER\" value=\"" + String(cfg.sipuser) + "\" size=\"20\"></td></tr>";
  html_buf += "<tr><td><h3>SIP-Passwort:</h3></td><td><input type=\"text\" name=\"SIPPASSWD\" value=\"" + String(cfg.sippasswd) + "\" size=\"20\"></td></tr>";
  html_buf += "<tr><td><h3>SIP-Nummer:</h3></td><td><input type=\"text\" name=\"SIPDIALNR\" value=\"" + String(cfg.sipdialnr) + "\" size=\"5\"></td></tr>";
  html_buf += "<tr><td><h3>SIP-Text:</h3></td><td><input type=\"text\" name=\"SIPDIALTEXT\" value=\"" + String(cfg.sipdialtext) + "\" size=\"16\"></td></tr>";
  html_buf += "<tr><td><h3>T&uuml;r&ouml;ffnertaste:</h3></td><td><input type=\"text\" name=\"SIPDIGIT\" value=\"" + String(cfg.sipdigit) + "\" size=\"1\"></td></tr>";
  html_buf += "<tr><td><h3>T&uuml;r&ouml;ffnerdauer:</h3></td><td><input type=\"text\" name=\"TUEROEFFNERDAUER\" value=\"" + String(cfg.einschaltdauer_tueroeffner) + "\" size=\"2\"> Sek.</td></tr>";
  html_buf += "<tr><td><h3>Klingeldauer:</h3></td><td><input type=\"text\" name=\"KLINGELDAUER\" value=\"" + String(cfg.telefon_klingeldauer) + "\" size=\"2\"> Sek.</td></tr>";
  html_buf += "<tr><td></td><td><input type=\"submit\" value=\"Speichern\"></form></td></tr></table>";
  html_buf += "</center></body></html>";
  server.send(200, "text/html", html_buf.c_str());
  return;
}

void reboot() {
  String html_buf = html_head();
  html_buf += "<META http-equiv=\"refresh\" content=\"15;URL=/\">";
  html_buf += "<h2>System wird neu gestartet...</h2>";
  html_buf += "</body></html>";
  server.send(200, "text/html", html_buf.c_str());
  delay(200);
  ESP.restart();
  return;
}

void tueroeffner() {
  if (dooropenerDelay == 0) {
    dooropenerDelay = millis();
    digitalWrite(TUEROEFFNERRELAIS_PIN, HIGH);
    systemlog(" Tueroeffner betaetigt per WebUI");
    String html_buf = html_head();
    html_buf += "<META http-equiv=\"refresh\" content=\"4;URL=/\">";
    html_buf += "<h2>T&uuml;r&ouml;ffner bet&auml;tigt</h2>";
    html_buf += "</body></html>";
    server.send(200, "text/html", html_buf.c_str());
    return;
  }
}

void telefon_ein_aus() {
  if (telefone_stumm == false) {
    telefone_stumm = true;
    if (cfg.mqtt_aktiv == 1) {
      mqtt_client.publish(topic_telefone_stumm, "true");
    }
    systemlog(" Telefonklingeln deaktiviert per WebUI");
  } else if (telefone_stumm == true) {
    telefone_stumm = false;
    if (cfg.mqtt_aktiv == 1) {
      mqtt_client.publish(topic_telefone_stumm, "false");
    }
    systemlog(" Telefonklingeln aktiviert per WebUI");
  }
  server.sendHeader("Location", "/");
  server.send(303);
  return;
}

void klingel_ein_aus() {
  if (klingel_stumm == false) {
    klingel_stumm = true;
    digitalWrite(KLINGELUNTERBRECHERRELAIS_PIN, HIGH);
    digitalWrite(LED_PIN, LOW);  // Setze Ausgang ledPin auf LOW / LED Ein
    if (cfg.mqtt_aktiv == 1) {
      mqtt_client.publish(topic_klingel_stumm, "true");
    }
    systemlog(" Klingel deaktiviert per WebUI");
  } else if (klingel_stumm == true) {
    klingel_stumm = false;
    digitalWrite(KLINGELUNTERBRECHERRELAIS_PIN, LOW);
    digitalWrite(LED_PIN, HIGH);  // Setze Ausgang ledPin auf LOW / LED Ein
    if (cfg.mqtt_aktiv == 1) {
      mqtt_client.publish(topic_klingel_stumm, "false");
    }
    systemlog(" Klingel aktiviert per WebUI");
  }
  server.sendHeader("Location", "/");
  server.send(303);
  return;
}

void dial() {
  if (telefone_stumm == false) {
    if (!bInDial) {
      handle_doorbellevent();                     //
      bInDial = 1;
    }
  }
   server.sendHeader("Location","/"); 
   server.send(303);
  return;
  }

void handleNotFound() {
  server.send(404, "text/plain", "404: Not found");
  return;
}


void handle_config() {
  cfg.ip[0] = server.arg("IP0").toInt();
  cfg.ip[1] = server.arg("IP1").toInt();
  cfg.ip[2] = server.arg("IP2").toInt();
  cfg.ip[3] = server.arg("IP3").toInt();
  cfg.mask[0] = server.arg("MASK0").toInt();
  cfg.mask[1] = server.arg("MASK1").toInt();
  cfg.mask[2] = server.arg("MASK2").toInt();
  cfg.mask[3] = server.arg("MASK3").toInt();
  cfg.gw[0] = server.arg("GW0").toInt();
  cfg.gw[1] = server.arg("GW1").toInt();
  cfg.gw[2] = server.arg("GW2").toInt();
  cfg.gw[3] = server.arg("GW3").toInt();
  cfg.dns[0] = server.arg("DNS0").toInt();
  cfg.dns[1] = server.arg("DNS1").toInt();
  cfg.dns[2] = server.arg("DNS2").toInt();
  cfg.dns[3] = server.arg("DNS3").toInt();
  cfg.mqttIP[0] = server.arg("MQTTIP0").toInt();
  cfg.mqttIP[1] = server.arg("MQTTIP1").toInt();
  cfg.mqttIP[2] = server.arg("MQTTIP2").toInt();
  cfg.mqttIP[3] = server.arg("MQTTIP3").toInt();
  server.arg("NTPSERVER").toCharArray(cfg.ntpServerName, 25);
  cfg.mqttport = server.arg("MQTTPORT").toInt();
  server.arg("WIFISSID").toCharArray(cfg.wifissid, 25);
  server.arg("WIFIPASSWORD").toCharArray(cfg.wifipassword, 40);
  server.arg("HOSTNAME").toCharArray(cfg.wifi_hostname, 25);
  server.arg("MQTTUSER").toCharArray(cfg.mqtt_user, 10);
  server.arg("MQTTPASSWD").toCharArray(cfg.mqtt_passwd, 10);
  server.arg("MQTTID").toCharArray(cfg.mqtt_id, 32);
  server.arg("SIPSERVER").toCharArray(cfg.sipserver, 20);
  server.arg("SIPUSER").toCharArray(cfg.sipuser, 20);
  server.arg("SIPPASSWD").toCharArray(cfg.sippasswd, 20);
  server.arg("SIPDIALNR").toCharArray(cfg.sipdialnr, 6);
  server.arg("SIPDIALTEXT").toCharArray(cfg.sipdialtext, 16);
  cfg.sipport = server.arg("SIPPORT").toInt();
  cfg.sipdigit = server.arg("SIPDIGIT").toInt();
  if (cfg.sipdigit == 0) { cfg.sipdigit = 1; }
  cfg.telefon_klingeldauer = server.arg("KLINGELDAUER").toInt();
  cfg.einschaltdauer_tueroeffner = server.arg("TUEROEFFNERDAUER").toInt();
  if (server.arg("DST") == "true") {
    cfg.dst_aktiv = 1;
  } else {
    cfg.dst_aktiv = 0;
  }
  if (server.arg("MQTTACTIVE") == "true") {
    cfg.mqtt_aktiv = 1;
  } else {
    cfg.mqtt_aktiv = 0;
  }
  EEPROM.begin(sizeof(cfg));
  EEPROM.put(0, cfg);
  EEPROM.commit();
  EEPROM.end();
  reboot();
  return;
}


